My Project: dgBody Class Reference

My Project

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
dgBody Class Referenceabstract

`#include <dgBody.h>`

Inheritance diagram for dgBody:

## Public Types

enum | dgRTTI { m_baseBodyRTTI = 1<<0, m_dynamicBodyRTTI = 1<<1, m_kinematicBodyRTTI = 1<<2, m_deformableBodyRTTI = 1<<3 }
enum | dgType { m_dynamicBody = 0, m_kinematicBody, m_deformableBody }
typedef void(dgApi * | OnBodyDestroy) (dgBody &me)
typedef void(dgApi * | OnApplyExtForceAndTorque) (dgBody &me, dgFloat32 timestep, dgInt32 threadIndex)
typedef void(dgApi * | OnMatrixUpdateCallback) (const dgBody &me, const dgMatrix &matrix, dgInt32 threadIndex)

## Public Member Functions

| dgBody ()
| dgBody (dgWorld *const world, const dgTree< const dgCollision *, dgInt32 > *const collisionNode, dgDeserialize serializeCallback, void *const userData)
virtual | ~dgBody ()
dgType | GetType () const
dgInt32 | IsRTTIType (dgUnsigned32 rtti) const
void * | GetUserData () const
void | SetUserData (void *const userData)
dgWorld * | GetWorld () const
const dgMatrix & | GetMatrix () const
const dgQuaternion & | GetRotation () const
const dgVector & | GetPosition () const
void | SetCentreOfMass (const dgVector &com)
const dgVector & | GetCentreOfMass () const
void | GetAABB (dgVector &p0, dgVector &p1) const
const dgVector & | GetOmega () const
const dgVector & | GetVelocity () const
const dgVector & | GetNetForce () const
const dgVector & | GetNetTorque () const
dgVector | GetVelocityAtPoint (const dgVector &point) const
void | SetOmega (const dgVector &omega)
void | SetVelocity (const dgVector &velocity)
dgUnsigned32 | GetGroupID () const
virtual void | SetGroupID (dgUnsigned32 id)
dgInt32 | GetUniqueID () const
bool | GetContinueCollisionMode () const
void | SetContinueCollisionMode (bool mode)
bool | GetCollisionWithLinkedBodies () const
void | SetCollisionWithLinkedBodies (bool state)
void | Freeze ()
void | Unfreeze ()
bool | GetFreeze () const
void | SetFreeze (bool state)
bool | GetSleepState () const
void | SetSleepState (bool state)
bool | GetAutoSleep () const
void | SetAutoSleep (bool state)
dgCollisionInstance * | GetCollision () const
dgBodyMasterList::dgListNode * | GetMasterList () const
OnBodyDestroy | GetDestructorCallback () const
void | SetDestructorCallback (OnBodyDestroy destructor)
OnMatrixUpdateCallback | GetMatrixUpdateCallback () const
void | SetMatrixUpdateCallback (OnMatrixUpdateCallback callback)
dgVector | GetMass () const
dgVector | GetInvMass () const
const dgMatrix & | GetInertiaMatrix () const
virtual dgMatrix | CalculateInertiaMatrix () const
virtual dgMatrix | CalculateInvInertiaMatrix () const
bool | IsCollidable () const
virtual void | SetCollidable (bool state)=0
virtual bool | IsInEquilibrium () const =0
virtual const dgVector & | GetForce () const =0
virtual const dgVector & | GetTorque () const =0
virtual void | AddForce (const dgVector &force)=0
virtual void | AddTorque (const dgVector &torque)=0
virtual void | SetForce (const dgVector &force)=0
virtual void | SetTorque (const dgVector &torque)=0
virtual dgFloat32 | GetLinearDamping () const =0
virtual dgVector | GetAngularDamping () const =0
virtual void | SetLinearDamping (dgFloat32 linearDamp)=0
virtual void | SetAngularDamping (const dgVector &angularDamp)=0
virtual void | AddDampingAcceleration ()=0
virtual void | SetMassMatrix (dgFloat32 mass, dgFloat32 Ix, dgFloat32 Iy, dgFloat32 Iz)
virtual void | SetMassProperties (dgFloat32 mass, const dgCollisionInstance *const collision)
virtual dgVector | PredictLinearVelocity (dgFloat32 timestep) const =0
virtual dgVector | PredictAngularVelocity (dgFloat32 timestep) const =0
virtual void | AddImpulse (const dgVector &pointVeloc, const dgVector &pointPosit)
virtual void | ApplyImpulsePair (const dgVector &linearImpulse, const dgVector &angularImpulse)
virtual void | ApplyImpulsesAtPoint (dgInt32 count, dgInt32 strideInBytes, const dgFloat32 *const impulseArray, const dgFloat32 *const pointArray)
virtual void | InvalidateCache ()
virtual void | SetMatrix (const dgMatrix &matrix)
virtual void | SetMatrixIgnoreSleep (const dgMatrix &matrix)
virtual void | IntegrateVelocity (dgFloat32 timestep)
virtual void | AttachCollision (dgCollisionInstance *const collision)
virtual void | ApplyExtenalForces (dgFloat32 timestep, dgInt32 threadIndex)=0
virtual OnApplyExtForceAndTorque | GetExtForceAndTorqueCallback () const =0
virtual void | SetExtForceAndTorqueCallback (OnApplyExtForceAndTorque callback)=0
virtual dgFloat32 | RayCast (const dgLineBox &line, OnRayCastAction filter, OnRayPrecastAction preFilter, void *const userData, dgFloat32 minT) const
virtual dgFloat32 | ConvexRayCast (const dgFastRayTest &ray, const dgCollisionInstance *const convexShape, const dgVector &shapeMinBox, const dgVector &shapeMaxBox, const dgMatrix &origin, const dgVector &shapeVeloc, OnRayCastAction filter, OnRayPrecastAction preFilter, void *const userData, dgFloat32 minT, dgInt32 threadId) const
virtual void | Serialize (const dgTree< dgInt32, const dgCollision *> *const collisionNode, dgSerialize serializeCallback, void *const userData)
virtual dgConstraint * | GetFirstJoint () const
virtual dgConstraint * | GetNextJoint (dgConstraint *const joint) const
virtual dgConstraint * | GetFirstContact () const
virtual dgConstraint * | GetNextContact (dgConstraint *const joint) const
virtual dgVector | CalculateInverseDynamicForce (const dgVector &desiredVeloc, dgFloat32 timestep) const
void | SetMatrixOriginAndRotation (const dgMatrix &matrix)

## Protected Member Functions

void | UpdateWorlCollisionMatrix () const
void | UpdateMatrix (dgFloat32 timestep, dgInt32 threadIndex)
void | UpdateCollisionMatrix (dgFloat32 timestep, dgInt32 threadIndex)
void | CalcInvInertiaMatrix ()
dgVector | GetApparentMass () const
void | SetAparentMassMatrix (const dgVector &massMatrix)

## Protected Attributes

dgMatrix | m_invWorldInertiaMatrix
dgMatrix | m_matrix
dgQuaternion | m_rotation
dgVector | m_mass
dgVector | m_invMass
dgVector | m_veloc
dgVector | m_omega
dgVector | m_minAABB
dgVector | m_maxAABB
dgVector | m_netForce
dgVector | m_netTorque
dgVector | m_localCentreOfMass
dgVector | m_globalCentreOfMass
dgVector | m_aparentMass
dgInt32 | m_index
dgInt32 | m_uniqueID
dgInt32 | m_bodyGroupId
dgInt32 | m_rtti
dgInt32 | m_type
dgUnsigned32 | m_dynamicsLru
dgUnsigned32 | m_genericLRUMark
dgThread::dgCriticalSection | m_criticalSectionLock
union {
dgUnsigned32 m_flags
struct {
dgUnsigned32 m_freeze: 1
dgUnsigned32 m_sleeping: 1
dgUnsigned32 m_autoSleep: 1
dgUnsigned32 m_equilibrium: 1
dgUnsigned32 m_continueCollisionMode: 1
dgUnsigned32 m_spawnnedFromCallback: 1
dgUnsigned32 m_collideWithLinkedBodies: 1
dgUnsigned32 m_inCallback: 1
dgUnsigned32 m_collidable: 1
dgUnsigned32 m_resting: 1
dgUnsigned32 m_active: 1
} |
}; |
void * | m_userData
dgWorld * | m_world
dgCollisionInstance * | m_collision
dgBroadPhase::dgNode * | m_collisionCell
dgBodyMasterList::dgListNode * | m_masterNode
OnBodyDestroy | m_destructor
OnMatrixUpdateCallback | m_matrixUpdate

## Friends

class | dgWorld
class | dgContact
class | dgConstraint
class | dgBroadPhase
class | dgAmpInstance
class | dgCollisionBVH
class | dgBroadPhaseNode
class | dgBodyMasterList
class | dgCollisionScene
class | dgCollisionConvex
class | dgCollisionCompound
class | dgCollisionUserMesh
class | dgWorldDynamicUpdate
class | dgBilateralConstraint
class | dgCollisionConvexPolygon
class | dgCollidingPairCollector

## Member Typedef Documentation

## § OnApplyExtForceAndTorque

typedef void(dgApi * dgBody::OnApplyExtForceAndTorque) (dgBody &me, dgFloat32 timestep, dgInt32 threadIndex)

## § OnBodyDestroy

typedef void(dgApi * dgBody::OnBodyDestroy) (dgBody &me)

## § OnMatrixUpdateCallback

typedef void(dgApi * dgBody::OnMatrixUpdateCallback) (const dgBody &me, const dgMatrix &matrix, dgInt32 threadIndex)

## Member Enumeration Documentation

## § dgRTTI

enum dgBody::dgRTTI

Enumerator
m_baseBodyRTTI |
m_dynamicBodyRTTI |
m_kinematicBodyRTTI |
m_deformableBodyRTTI |

## § dgType

enum dgBody::dgType

Enumerator
m_dynamicBody |
m_kinematicBody |
m_deformableBody |

## Constructor & Destructor Documentation

## § dgBody() [1/2]

dgBody::dgBody | ( |  | ) |

## § dgBody() [2/2]

dgBody::dgBody | ( | dgWorld *const | world,
|  | const dgTree< const dgCollision *, dgInt32 > *const | collisionNode,
|  | dgDeserialize | serializeCallback,
|  | void *const | userData
| ) |  |

## § ~dgBody()

dgBody::~dgBody | ( |  | ) |

virtual

## Member Function Documentation

## § AddDampingAcceleration()

virtual void dgBody::AddDampingAcceleration | ( |  | ) |

pure virtual

Implemented in dgKinematicBody, and dgDeformableBody.

## § AddForce()

virtual void dgBody::AddForce | ( | const dgVector & | force | ) |

pure virtual

Implemented in dgDeformableBody, dgDynamicBody, and dgKinematicBody.

## § AddImpulse()

void dgBody::AddImpulse | ( | const dgVector & | pointVeloc,
|  | const dgVector & | pointPosit
| ) |  |

virtual

Reimplemented in dgDeformableBody.

## § AddTorque()

virtual void dgBody::AddTorque | ( | const dgVector & | torque | ) |

pure virtual

Implemented in dgDeformableBody, dgDynamicBody, and dgKinematicBody.

## § ApplyExtenalForces()

virtual void dgBody::ApplyExtenalForces | ( | dgFloat32 | timestep,
|  | dgInt32 | threadIndex
| ) |  |

pure virtual

Implemented in dgDynamicBody, dgDeformableBody, and dgKinematicBody.

## § ApplyImpulsePair()

void dgBody::ApplyImpulsePair | ( | const dgVector & | linearImpulse,
|  | const dgVector & | angularImpulse
| ) |  |

virtual

Reimplemented in dgDeformableBody.

## § ApplyImpulsesAtPoint()

void dgBody::ApplyImpulsesAtPoint | ( | dgInt32 | count,
|  | dgInt32 | strideInBytes,
|  | const dgFloat32 *const | impulseArray,
|  | const dgFloat32 *const | pointArray
| ) |  |

virtual

Reimplemented in dgDeformableBody.

## § AttachCollision()

void dgBody::AttachCollision | ( | dgCollisionInstance *const | collision | ) |

virtual

Reimplemented in dgDeformableBody, and dgDynamicBody.

## § CalcInvInertiaMatrix()

DG_INLINE void dgBody::CalcInvInertiaMatrix | ( |  | ) |

protected

## § CalculateInertiaMatrix()

dgMatrix dgBody::CalculateInertiaMatrix | ( |  | ) | const

virtual

Reimplemented in dgDeformableBody.

## § CalculateInverseDynamicForce()

dgVector dgBody::CalculateInverseDynamicForce | ( | const dgVector & | desiredVeloc,
|  | dgFloat32 | timestep
| ) |  | const

virtual

## § CalculateInvInertiaMatrix()

dgMatrix dgBody::CalculateInvInertiaMatrix | ( |  | ) | const

virtual

Reimplemented in dgDeformableBody.

## § ConvexRayCast()

dgFloat32 dgBody::ConvexRayCast | ( | const dgFastRayTest & | ray,
|  | const dgCollisionInstance *const | convexShape,
|  | const dgVector & | shapeMinBox,
|  | const dgVector & | shapeMaxBox,
|  | const dgMatrix & | origin,
|  | const dgVector & | shapeVeloc,
|  | OnRayCastAction | filter,
|  | OnRayPrecastAction | preFilter,
|  | void *const | userData,
|  | dgFloat32 | minT,
|  | dgInt32 | threadId
| ) |  | const

virtual

## § Freeze()

void dgBody::Freeze | ( |  | ) |

## § GetAABB()

DG_INLINE void dgBody::GetAABB | ( | dgVector & | p0,
|  | dgVector & | p1
| ) |  | const

## § GetAngularDamping()

virtual dgVector dgBody::GetAngularDamping | ( |  | ) | const

pure virtual

Implemented in dgDeformableBody, dgDynamicBody, and dgKinematicBody.

## § GetApparentMass()

DG_INLINE dgVector dgBody::GetApparentMass | ( |  | ) | const

protected

## § GetAutoSleep()

DG_INLINE bool dgBody::GetAutoSleep | ( |  | ) | const

## § GetCentreOfMass()

DG_INLINE const dgVector & dgBody::GetCentreOfMass | ( |  | ) | const

## § GetCollision()

DG_INLINE dgCollisionInstance * dgBody::GetCollision | ( |  | ) | const

## § GetCollisionWithLinkedBodies()

DG_INLINE bool dgBody::GetCollisionWithLinkedBodies | ( |  | ) | const

## § GetContinueCollisionMode()

DG_INLINE bool dgBody::GetContinueCollisionMode | ( |  | ) | const

## § GetDestructorCallback()

DG_INLINE dgBody::OnBodyDestroy dgBody::GetDestructorCallback | ( |  | ) | const

## § GetExtForceAndTorqueCallback()

virtual OnApplyExtForceAndTorque dgBody::GetExtForceAndTorqueCallback | ( |  | ) | const

pure virtual

Implemented in dgDeformableBody, dgDynamicBody, and dgKinematicBody.

## § GetFirstContact()

dgConstraint * dgBody::GetFirstContact | ( |  | ) | const

virtual

## § GetFirstJoint()

dgConstraint * dgBody::GetFirstJoint | ( |  | ) | const

virtual

## § GetForce()

virtual const dgVector& dgBody::GetForce | ( |  | ) | const

pure virtual

Implemented in dgDeformableBody, dgDynamicBody, and dgKinematicBody.

## § GetFreeze()

DG_INLINE bool dgBody::GetFreeze | ( |  | ) | const

## § GetGroupID()

DG_INLINE dgUnsigned32 dgBody::GetGroupID | ( |  | ) | const

## § GetInertiaMatrix()

DG_INLINE const dgMatrix & dgBody::GetInertiaMatrix | ( |  | ) | const

## § GetInvMass()

DG_INLINE dgVector dgBody::GetInvMass | ( |  | ) | const

## § GetLinearDamping()

virtual dgFloat32 dgBody::GetLinearDamping | ( |  | ) | const

pure virtual

Implemented in dgDeformableBody, dgDynamicBody, and dgKinematicBody.

## § GetMass()

DG_INLINE dgVector dgBody::GetMass | ( |  | ) | const

## § GetMasterList()

DG_INLINE dgBodyMasterList::dgListNode * dgBody::GetMasterList | ( |  | ) | const

## § GetMatrix()

DG_INLINE const dgMatrix & dgBody::GetMatrix | ( |  | ) | const

## § GetMatrixUpdateCallback()

DG_INLINE dgBody::OnMatrixUpdateCallback dgBody::GetMatrixUpdateCallback | ( |  | ) | const

## § GetNetForce()

DG_INLINE const dgVector & dgBody::GetNetForce | ( |  | ) | const

## § GetNetTorque()

DG_INLINE const dgVector & dgBody::GetNetTorque | ( |  | ) | const

## § GetNextContact()

dgConstraint * dgBody::GetNextContact | ( | dgConstraint *const | joint | ) | const

virtual

## § GetNextJoint()

dgConstraint * dgBody::GetNextJoint | ( | dgConstraint *const | joint | ) | const

virtual

## § GetOmega()

DG_INLINE const dgVector & dgBody::GetOmega | ( |  | ) | const

## § GetPosition()

DG_INLINE const dgVector & dgBody::GetPosition | ( |  | ) | const

## § GetRotation()

DG_INLINE const dgQuaternion & dgBody::GetRotation | ( |  | ) | const

## § GetSleepState()

DG_INLINE bool dgBody::GetSleepState | ( |  | ) | const

## § GetTorque()

virtual const dgVector& dgBody::GetTorque | ( |  | ) | const

pure virtual

Implemented in dgDeformableBody, dgDynamicBody, and dgKinematicBody.

## § GetType()

DG_INLINE dgBody::dgType dgBody::GetType | ( |  | ) | const

## § GetUniqueID()

DG_INLINE dgInt32 dgBody::GetUniqueID | ( |  | ) | const

## § GetUserData()

DG_INLINE void * dgBody::GetUserData | ( |  | ) | const

## § GetVelocity()

DG_INLINE const dgVector & dgBody::GetVelocity | ( |  | ) | const

## § GetVelocityAtPoint()

DG_INLINE dgVector dgBody::GetVelocityAtPoint | ( | const dgVector & | point | ) | const

## § GetWorld()

DG_INLINE dgWorld * dgBody::GetWorld | ( |  | ) | const

## § IntegrateVelocity()

void dgBody::IntegrateVelocity | ( | dgFloat32 | timestep | ) |

virtual

## § InvalidateCache()

void dgBody::InvalidateCache | ( |  | ) |

virtual

Reimplemented in dgDynamicBody.

## § IsCollidable()

DG_INLINE bool dgBody::IsCollidable | ( |  | ) | const

## § IsInEquilibrium()

virtual bool dgBody::IsInEquilibrium | ( |  | ) | const

pure virtual

Implemented in dgDynamicBody, dgKinematicBody, and dgDeformableBody.

## § IsRTTIType()

DG_INLINE dgInt32 dgBody::IsRTTIType | ( | dgUnsigned32 | rtti | ) | const

## § PredictAngularVelocity()

virtual dgVector dgBody::PredictAngularVelocity | ( | dgFloat32 | timestep | ) | const

pure virtual

Implemented in dgDeformableBody, dgDynamicBody, and dgKinematicBody.

## § PredictLinearVelocity()

virtual dgVector dgBody::PredictLinearVelocity | ( | dgFloat32 | timestep | ) | const

pure virtual

Implemented in dgDeformableBody, dgDynamicBody, and dgKinematicBody.

## § RayCast()

dgFloat32 dgBody::RayCast | ( | const dgLineBox & | line,
|  | OnRayCastAction | filter,
|  | OnRayPrecastAction | preFilter,
|  | void *const | userData,
|  | dgFloat32 | minT
| ) |  | const

virtual

## § Serialize()

void dgBody::Serialize | ( | const dgTree< dgInt32, const dgCollision *> *const | collisionNode,
|  | dgSerialize | serializeCallback,
|  | void *const | userData
| ) |  |

virtual

Reimplemented in dgDynamicBody, dgKinematicBody, and dgDeformableBody.

## § SetAngularDamping()

virtual void dgBody::SetAngularDamping | ( | const dgVector & | angularDamp | ) |

pure virtual

Implemented in dgDeformableBody, dgDynamicBody, and dgKinematicBody.

## § SetAparentMassMatrix()

void dgBody::SetAparentMassMatrix | ( | const dgVector & | massMatrix | ) |

protected

## § SetAutoSleep()

DG_INLINE void dgBody::SetAutoSleep | ( | bool | state | ) |

## § SetCentreOfMass()

DG_INLINE void dgBody::SetCentreOfMass | ( | const dgVector & | com | ) |

## § SetCollidable()

virtual void dgBody::SetCollidable | ( | bool | state | ) |

pure virtual

Implemented in dgDeformableBody, dgDynamicBody, and dgKinematicBody.

## § SetCollisionWithLinkedBodies()

DG_INLINE void dgBody::SetCollisionWithLinkedBodies | ( | bool | state | ) |

## § SetContinueCollisionMode()

DG_INLINE void dgBody::SetContinueCollisionMode | ( | bool | mode | ) |

## § SetDestructorCallback()

DG_INLINE void dgBody::SetDestructorCallback | ( | OnBodyDestroy | destructor | ) |

## § SetExtForceAndTorqueCallback()

virtual void dgBody::SetExtForceAndTorqueCallback | ( | OnApplyExtForceAndTorque | callback | ) |

pure virtual

Implemented in dgDeformableBody, dgDynamicBody, and dgKinematicBody.

## § SetForce()

virtual void dgBody::SetForce | ( | const dgVector & | force | ) |

pure virtual

Implemented in dgDeformableBody, dgDynamicBody, and dgKinematicBody.

## § SetFreeze()

void dgBody::SetFreeze | ( | bool | state | ) |

## § SetGroupID()

DG_INLINE void dgBody::SetGroupID | ( | dgUnsigned32 | id | ) |

virtual

## § SetLinearDamping()

virtual void dgBody::SetLinearDamping | ( | dgFloat32 | linearDamp | ) |

pure virtual

Implemented in dgDeformableBody, dgDynamicBody, and dgKinematicBody.

## § SetMassMatrix()

void dgBody::SetMassMatrix | ( | dgFloat32 | mass,
|  | dgFloat32 | Ix,
|  | dgFloat32 | Iy,
|  | dgFloat32 | Iz
| ) |  |

virtual

Reimplemented in dgDeformableBody.

## § SetMassProperties()

void dgBody::SetMassProperties | ( | dgFloat32 | mass,
|  | const dgCollisionInstance *const | collision
| ) |  |

virtual

Reimplemented in dgDeformableBody.

## § SetMatrix()

void dgBody::SetMatrix | ( | const dgMatrix & | matrix | ) |

virtual

Reimplemented in dgDeformableBody.

## § SetMatrixIgnoreSleep()

void dgBody::SetMatrixIgnoreSleep | ( | const dgMatrix & | matrix | ) |

virtual

Reimplemented in dgDynamicBody.

## § SetMatrixOriginAndRotation()

DG_INLINE void dgBody::SetMatrixOriginAndRotation | ( | const dgMatrix & | matrix | ) |

## § SetMatrixUpdateCallback()

DG_INLINE void dgBody::SetMatrixUpdateCallback | ( | OnMatrixUpdateCallback | callback | ) |

## § SetOmega()

DG_INLINE void dgBody::SetOmega | ( | const dgVector & | omega | ) |

## § SetSleepState()

DG_INLINE void dgBody::SetSleepState | ( | bool | state | ) |

## § SetTorque()

virtual void dgBody::SetTorque | ( | const dgVector & | torque | ) |

pure virtual

Implemented in dgDeformableBody, dgDynamicBody, and dgKinematicBody.

## § SetUserData()

DG_INLINE void dgBody::SetUserData | ( | void *const | userData | ) |

## § SetVelocity()

DG_INLINE void dgBody::SetVelocity | ( | const dgVector & | velocity | ) |

## § Unfreeze()

void dgBody::Unfreeze | ( |  | ) |

## § UpdateCollisionMatrix()

void dgBody::UpdateCollisionMatrix | ( | dgFloat32 | timestep,
|  | dgInt32 | threadIndex
| ) |  |

protected

## § UpdateMatrix()

void dgBody::UpdateMatrix | ( | dgFloat32 | timestep,
|  | dgInt32 | threadIndex
| ) |  |

protected

## § UpdateWorlCollisionMatrix()

void dgBody::UpdateWorlCollisionMatrix | ( |  | ) | const

protected

## Friends And Related Function Documentation

## § dgAmpInstance

friend class dgAmpInstance

friend

## § dgBilateralConstraint

friend class dgBilateralConstraint

friend

## § dgBodyMasterList

friend class dgBodyMasterList

friend

## § dgBroadPhase

friend class dgBroadPhase

friend

## § dgBroadPhaseNode

friend class dgBroadPhaseNode

friend

## § dgCollidingPairCollector

friend class dgCollidingPairCollector

friend

## § dgCollisionBVH

friend class dgCollisionBVH

friend

## § dgCollisionCompound

friend class dgCollisionCompound

friend

## § dgCollisionConvex

friend class dgCollisionConvex

friend

## § dgCollisionConvexPolygon

friend class dgCollisionConvexPolygon

friend

## § dgCollisionScene

friend class dgCollisionScene

friend

## § dgCollisionUserMesh

friend class dgCollisionUserMesh

friend

## § dgConstraint

friend class dgConstraint

friend

## § dgContact

friend class dgContact

friend

## § dgWorld

friend class dgWorld

friend

## § dgWorldDynamicUpdate

friend class dgWorldDynamicUpdate

friend

## Member Data Documentation

## § @22

union { ... }

## § m_active

dgUnsigned32 dgBody::m_active

## § m_aparentMass

dgVector dgBody::m_aparentMass

protected

## § m_autoSleep

dgUnsigned32 dgBody::m_autoSleep

## § m_bodyGroupId

dgInt32 dgBody::m_bodyGroupId

protected

## § m_collidable

dgUnsigned32 dgBody::m_collidable

## § m_collideWithLinkedBodies

dgUnsigned32 dgBody::m_collideWithLinkedBodies

## § m_collision

dgCollisionInstance* dgBody::m_collision

protected

## § m_collisionCell

dgBroadPhase::dgNode* dgBody::m_collisionCell

protected

## § m_continueCollisionMode

dgUnsigned32 dgBody::m_continueCollisionMode

## § m_criticalSectionLock

dgThread::dgCriticalSection dgBody::m_criticalSectionLock

protected

## § m_destructor

OnBodyDestroy dgBody::m_destructor

protected

## § m_dynamicsLru

dgUnsigned32 dgBody::m_dynamicsLru

protected

## § m_equilibrium

dgUnsigned32 dgBody::m_equilibrium

## § m_flags

dgUnsigned32 dgBody::m_flags

## § m_freeze

dgUnsigned32 dgBody::m_freeze

## § m_genericLRUMark

dgUnsigned32 dgBody::m_genericLRUMark

protected

## § m_globalCentreOfMass

dgVector dgBody::m_globalCentreOfMass

protected

## § m_inCallback

dgUnsigned32 dgBody::m_inCallback

## § m_index

dgInt32 dgBody::m_index

protected

## § m_invMass

dgVector dgBody::m_invMass

protected

## § m_invWorldInertiaMatrix

dgMatrix dgBody::m_invWorldInertiaMatrix

protected

## § m_localCentreOfMass

dgVector dgBody::m_localCentreOfMass

protected

## § m_mass

dgVector dgBody::m_mass

protected

## § m_masterNode

dgBodyMasterList::dgListNode* dgBody::m_masterNode

protected

## § m_matrix

dgMatrix dgBody::m_matrix

protected

## § m_matrixUpdate

OnMatrixUpdateCallback dgBody::m_matrixUpdate

protected

## § m_maxAABB

dgVector dgBody::m_maxAABB

protected

## § m_minAABB

dgVector dgBody::m_minAABB

protected

## § m_netForce

dgVector dgBody::m_netForce

protected

## § m_netTorque

dgVector dgBody::m_netTorque

protected

## § m_omega

dgVector dgBody::m_omega

protected

## § m_resting

dgUnsigned32 dgBody::m_resting

## § m_rotation

dgQuaternion dgBody::m_rotation

protected

## § m_rtti

dgInt32 dgBody::m_rtti

protected

## § m_sleeping

dgUnsigned32 dgBody::m_sleeping

## § m_spawnnedFromCallback

dgUnsigned32 dgBody::m_spawnnedFromCallback

## § m_type

dgInt32 dgBody::m_type

protected

## § m_uniqueID

dgInt32 dgBody::m_uniqueID

protected

## § m_userData

void* dgBody::m_userData

protected

## § m_veloc

dgVector dgBody::m_veloc

protected

## § m_world

dgWorld* dgBody::m_world

protected

The documentation for this class was generated from the following files:

- dynamics.mod/NewtonDynamics/source/physics/dgBody.h
- dynamics.mod/NewtonDynamics/source/physics/dgBody.cpp